---
title: WAI ARIA Live Regions/API Support
slug: Web/Guide/AJAX/WAI_ARIA_Live_Regions_API_Support
tags:
  - AJAX
  - Accessibility
---
<p>{{ Fx_minversion_header(3) }}</p>
<div class="warning">
 These notes are for developers of screen readers. Developers should use the <a href="/en/ARIA/Live_Regions">ARIA live regions developer documentation</a>.</div>
<p>Firefox 3 contains important improvements to the way the Mozilla engine exposes live changes in a document.</p>
<p>These features will help screen reader developers improve the quality and performance of live region support, both for pages that are marked up with ARIA live region markup, and for pages where the author did not add any additional markup.</p>
<p>Please read the <a class="external" href="http://www.w3.org/WAI/PF/aria/#liveregions">ARIA spec</a> or the <a href="/en/docs/AJAX:WAI_ARIA_Live_Regions" title="en/docs/AJAX:WAI_ARIA_Live_Regions">live region report</a> to learn about ARIA live region markup.</p>
<p>As always, we're open to questions and suggestions for changes in <a class="external" href="http://www.mozilla.org/access/#community">community forums</a>.</p>
<h2 id="Events_fired_for_web_page_mutations">Events fired for web page mutations</h2>
<table class="standard-table">
 <tbody>
  <tr>
   <th>What changed in document?</th>
   <th>ATK/AT-SPI event</th>
   <th>IAccessible2 event</th>
  </tr>
  <tr>
   <td>Object about to be hidden or removed</td>
   <td>children_changed::remove (fired on the parent, with event data pointing to the child index of the accessible object to be removed)</td>
   <td>EVENT_OBJECT_HIDE* (fired on the actual accessible object about to go away)</td>
  </tr>
  <tr>
   <td>Object shown or inserted</td>
   <td>children_changed::add (fired on the parent, with event data pointing to the child index of the inserted accessible object)</td>
   <td>EVENT_OBJECT_SHOW* (fired on the actual new accessible object)</td>
  </tr>
  <tr>
   <td>Object replaced with different object (this happens especially if an object's interfaces or role changes)</td>
   <td>children_changed::remove followed immediately by children_change::add</td>
   <td>EVENT_OBJECT_HIDE followed immediately by EVENT_OBJECT_SHOW</td>
  </tr>
  <tr>
   <td>Text removed</td>
   <td>text_changed::delete</td>
   <td>IA2_EVENT_TEXT_REMOVED (use IAccessibleText::get_oldText to retrieve the offsets and removed text)</td>
  </tr>
  <tr>
   <td>Text inserted</td>
   <td>text_changed::insert</td>
   <td>IA2_EVENT_TEXT_INSERTED (use IAccessibleText::get_newText to retrieve the offsets and inserted text)</td>
  </tr>
  <tr>
   <td>Text replaced</td>
   <td>text_changed::delete followed immediately by text_changed::insert</td>
   <td>IA2_EVENT_TEXT_REMOVED followed immediately by IA2_EVENT_TEXT_INSERTED</td>
  </tr>
 </tbody>
</table>
<p><span class="nowiki">*</span> We do not use MSAA's CREATE/DESTROY at the request of screen reader vendors, who avoid those events because they cause crashes on some important system -- SHOW/HIDE are the equivalent of those events.</p>
<h2 id="Retrieving_author-supplied_ARIA_live_region_semantics_from_an_event">Retrieving author-supplied ARIA live region semantics from an event</h2>
<p>For any mutation event in a page, the author can get the following object attributes from the event object, if they are defined on some ancestor element (closest ancestor wins):</p>
<table class="standard-table">
 <tbody>
  <tr>
   <th>Object attribute name</th>
   <th>Possible values</th>
   <th>Default value if not specified</th>
   <th>Meaning</th>
   <th>ARIA markup if required</th>
  </tr>
  <tr>
   <td>container-live</td>
   <td>"off" <span class="nowiki">|</span> "polite" <span class="nowiki">|</span> "assertive"</td>
   <td>"off"</td>
   <td>Interruption policy</td>
   <td>aria-live on ancestor element</td>
  </tr>
  <tr>
   <td>container-relevant</td>
   <td>"{{ mediawiki.external('additions') }} {{ mediawiki.external('removals') }} {{ mediawiki.external('text') }}" <span class="nowiki">|</span> "all"</td>
   <td>"additions text"</td>
   <td>What types of mutations are possibly relevant? See {{ mediawiki.external('#Events_fired_for_web_page_mutations the mutation events list') }} to match the type of event with this attribute's value, to determine whether the author believed the event should be presented to the user or not.</td>
   <td>aria-relevant on ancestor element</td>
  </tr>
  <tr>
   <td>container-busy</td>
   <td>"true" <span class="nowiki">|</span> "false" <span class="nowiki">|</span> "error"</td>
   <td>"false"</td>
   <td>The current changes are not yet complete. A state change event for the A11y API's BUSY state will be fired on the container object currently marked as BUSY, once it is no longer BUSY. This is especially important in atomic regions. The entire atomic region should be presented once when it is finally no longer BUSY.</td>
   <td>aria-busy on ancestor element</td>
  </tr>
  <tr>
   <td>container-atomic</td>
   <td>"true" <span class="nowiki">|</span> "false"</td>
   <td>"false"</td>
   <td>Is this change inside a region that should always be presented at once. If yes, member-of relation will point to the root of the region (see next section)</td>
   <td>aria-atomic on ancestor element</td>
  </tr>
  <tr>
   <td>member-of</td>
   <td>If container-atomic=true, points to an ancestor accessible object (thus it is actually an accessible relation, not object attribute)</td>
   <td>Not in atomic region if not provided</td>
   <td>Points to the root of the atomic container that this object is in. This will always be an ancestor of the current object.</td>
   <td>aria-atomic on ancestor element</td>
  </tr>
  <tr>
   <td>event-from-input</td>
   <td>"true" <span class="nowiki">|</span> "false"<br>
    (described more below)</td>
   <td>Browser could not calculate this</td>
   <td>Was the root cause of this event explicit user input?</td>
   <td>Does not require author's cooperation.</td>
  </tr>
 </tbody>
</table>
<p>The "container-" prefix is so named because the attribute describes what the final computed property of similar name is for that node. This means that the AT does not need to traverse up the parent chain to get this information. At this time, for properties where the container-{{ mediawiki.external('name') }} attribute has not been set, the AT must have code to fall back on the default value as defined in the W3C spec.</p>
<h2 id="Determining_if_event_was_from_user_input">Determining if event was from user input</h2>
<p>All events will now provide information about whether the event was caused by user input, or was something that the web page caused. This information is retrieved differently on each platform, because some platforms use asynchronous events.</p>
<p>In IAccessible2, this is retrieved from the object attribute "event-from-input", which will be set to "true" or "false". If it is not present, then something went wrong and Mozilla was not able to provide this information. This information is available only for EVENT_SHOW, EVENT_HIDE, IA2_EVENT_TEXT_INSERTED and IA2_EVENT_TEXT_REMOVED.</p>
<p>For ATK/AT-SPI, this information is retrieved by checking the event name. If the event name has ":system" appended to it, then it is /not/ from user input. The ":system" string is calculated for children-changed and text-changed events.</p>
<p>Why is this useful? The majority of AJAX pages do not provide live region markup, but still need to be as usable as possible. It is difficult for a screen reader to decide when to interrupt a user with changes on a page. If the screen reader automatically reads too much, then the web page will be too annoying to use. If the screen reader doesn't read anything, then the user may miss important information.</p>
<p>It is believed this information will be useful for heuristics. Often, changes in a page that are directly caused by a user's keystrokes should be read. They are synchronous with what the user is doing and can thus likely be read without disorienting the user. Once the user presses the next key the speech will move on to echoing that key anyway. The screen reader may wish to take other factors into account, such as the type of change, the size of the change, where the change occurred, etc. This is a potential area for innovation in screen readers.</p>
<table class="standard-table">
 <tbody>
  <tr>
   <th>Most recent occurance</th>
   <th>User input?</th>
  </tr>
  <tr>
   <td>Key presses</td>
   <td>Yes</td>
  </tr>
  <tr>
   <td>Mouse clicks</td>
   <td>Yes</td>
  </tr>
  <tr>
   <td>Mouse hovers</td>
   <td>No</td>
  </tr>
  <tr>
   <td>Page load events</td>
   <td>No</td>
  </tr>
 </tbody>
</table>
<p>Everything else, including focus changes, timer callbacks, XMLHttpRequest callbacks, etc. are neutral. They are only counted as user input if the original reason they happened was because of user input.</p>
<h2 id="What_Should_Screen_Readers_Present">What Should Screen Readers Present?</h2>
<p>Please read the live region section of the <a href="/en/ARIA/ARIA_Screen_Reader_Implementors_Guide#Live_Regions" title="http://developer.mozilla.org/editor/fckeditor/core/editor/En/ARIA_Screen_Reader_Implementors_Guide#Live_Regions">WAI-ARIA Screen Reader Implementor's Guide</a>.</p>
